<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_TransferType StructType
 * @subpackage Structs
 */
class JP_TransferType extends AbstractStructBase
{
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - use: required
     * @var int
     */
    public $Code;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The ParentCode
     * @var int
     */
    public $ParentCode;
    /**
     * The IgnoresMargin
     * @var bool
     */
    public $IgnoresMargin;
    /**
     * Constructor method for JP_TransferType
     * @uses JP_TransferType::setCode()
     * @uses JP_TransferType::setName()
     * @uses JP_TransferType::setParentCode()
     * @uses JP_TransferType::setIgnoresMargin()
     * @param int $code
     * @param string $name
     * @param int $parentCode
     * @param bool $ignoresMargin
     */
    public function __construct($code = null, $name = null, $parentCode = null, $ignoresMargin = null)
    {
        $this
            ->setCode($code)
            ->setName($name)
            ->setParentCode($parentCode)
            ->setIgnoresMargin($ignoresMargin);
    }
    /**
     * Get Code value
     * @return int
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param int $code
     * @return \StructType\JP_TransferType
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !(is_int($code) || ctype_digit($code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_TransferType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get ParentCode value
     * @return int|null
     */
    public function getParentCode()
    {
        return $this->ParentCode;
    }
    /**
     * Set ParentCode value
     * @param int $parentCode
     * @return \StructType\JP_TransferType
     */
    public function setParentCode($parentCode = null)
    {
        // validation for constraint: int
        if (!is_null($parentCode) && !(is_int($parentCode) || ctype_digit($parentCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($parentCode, true), gettype($parentCode)), __LINE__);
        }
        $this->ParentCode = $parentCode;
        return $this;
    }
    /**
     * Get IgnoresMargin value
     * @return bool|null
     */
    public function getIgnoresMargin()
    {
        return $this->IgnoresMargin;
    }
    /**
     * Set IgnoresMargin value
     * @param bool $ignoresMargin
     * @return \StructType\JP_TransferType
     */
    public function setIgnoresMargin($ignoresMargin = null)
    {
        // validation for constraint: boolean
        if (!is_null($ignoresMargin) && !is_bool($ignoresMargin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ignoresMargin, true), gettype($ignoresMargin)), __LINE__);
        }
        $this->IgnoresMargin = $ignoresMargin;
        return $this;
    }
}
